class ConverterService
  attr_reader :json_file
  attr_reader :locales_path

  def initialize(json_file={})
    @locales_path = get_file_path
    @json_file = json_file
  end

  def get_file_path
    if Kernel.const_defined? 'Rails'
      File.join(Rails.root, 'config/locales')
    else
      raise 'I need Rails to run!'
    end
  end

# method for I M P O R T I N G
  def parse_json_to_yml # creates individual ymls for each locale
    locale_arr = []
    @json_file.keys.each { |key| locale_arr << {key => @json_file[key]} }

    locale_arr.each do |locale|
      y_file = File.open("#{@locales_path}/#{locale.keys.first}.yml", 'w')
      y_file.write(YAML.dump(locale))
      y_file.close
    end
  end


# methods for E X P O R T I N G
  def parse_yml_to_json(yml_file)
    j_file = YAML.load_file(File.open("#{yml_file}", 'r'))
  end

  def iterate_locale_dir # returns full json of all ymls
    Dir.foreach(@locales_path) do |filename|

      next if filename == '.' or filename == '..' or filename.include? "devise"

      parsed_yml = parse_yml_to_json("#{@locales_path}/#{filename}")
      key = parsed_yml.keys.first

      @json_file[key] = parsed_yml[key]
    end
    @json_file = @json_file.to_json
  end
end
