require 'yaml'
require 'json'
require 'fileutils'
require 'pry'

require "polyglot/sync/version"

require 'polyglot/sync/engine' if defined?(Rails)

module Polyglot
  module Sync
    class Error < StandardError; end

    class << self
      attr_accessor :configuration
    end

    def self.configure
      self.configuration ||= Configuration.new
      yield(configuration)
    end

    class Configuration
      attr_accessor :aws_s3_bucket_name
      attr_accessor :project_slug
      attr_accessor :organization_secret_key
      attr_accessor :aws_cloudfront_host
      attr_accessor :aws_region

      def initialize
        @aws_region = 'default thing'
      end
    end
  end
end
